# 使用注意事项

## 侧滑手势处理

[侧滑手势处理文档地址](https://github.com/pujiaxin33/JXCategoryView/blob/master/Document/%E4%BE%A7%E6%BB%91%E6%89%8B%E5%8A%BF%E5%A4%84%E7%90%86.md)

## JXCategoryView状态刷新

初始化过后，有新的数据源、属性配置有变动时（比如从服务器拉取回来数据，重新赋值titles），需要调用`reloadData`方法刷新状态。

## contentScrollView关联说明

JXCategoryView没有与contentScrollView强关联，你甚至可以不设置这个属性，把它当做简单的SegmentedControl。他们之间布局没有任何要求，可以把JXCategoryView放入导航栏、UITableViewSectionHeader等任何你想要的地方。

## 点击Item之后contentScrollView切换效果

系统内部通过代码`[self.contentScrollView setContentOffset:CGPointMake(targetIndex*self.contentScrollView.bounds.size.width, 0) animated:YES]`实现切换。

你可以通过实现代理方法`- (void)categoryView:(JXCategoryBaseView *)categoryView didClickedItemContentScrollViewTransitionToIndex:(NSInteger)index`进行自定义，比如把`animated`设置为NO

## 列表cell点击跳转示例

Demo的使用方法是给列表新增一个属性：`@property (nonatomic, strong) UINavigationController *naviController`，然后将父VC的navigationController赋值给它。这样列表的cell点击就可以通过自定义的`naviController`属性进行跳转了。详情参考源码[LoadDataListBaseViewController](https://github.com/pujiaxin33/JXCategoryView/blob/master/JXCategoryView/Example/LoadData/LoadDataListBaseViewController.h)

## 代码选中指定index

当业务需要某个时刻要跳转到指定index，比如当前index=0，用户点击了某个按钮，需要立即跳转到index=3的位置，使用下列代码即可：
```Objective-c
    [self.categoryView selectItemAtIndex:3];
    [self.listContainerView didClickSelectedItemAtIndex:3];
```

## JXCategoryView.collectionView高度取整说明

高度取整代码：
```Objective-c
- (void)layoutSubviews {
    [super layoutSubviews];

    self.collectionView.frame = CGRectMake(0, 0, self.bounds.size.width, floor(self.bounds.size.height));
}
```
部分使用者为了适配不同的手机屏幕尺寸，JXCategoryView的宽高比要求保持一样。所以它的高度就会因为不同宽度的屏幕而不一样。计算出来的高度，有时候会是位数很长的浮点数，如果把这个高度设置给UICollectionView就会触发内部的一个错误。所以，为了规避这个问题，在这里对高度统一向下取整。
如果向下取整导致了你的页面异常，请自己重新设置JXCategoryView的高度，保证为整数即可。

## 对父VC的automaticallyAdjustsScrollViewInsets属性设置为NO

因为JXCategoryView内部使用了UICollectionView，在某些系统会对内部的UICollectionView进行错误的调整。所以，内部会自己找到父VC，然后将其automaticallyAdjustsScrollViewInsets属性设置为NO。
```Objective-c
- (void)willMoveToSuperview:(UIView *)newSuperview {
    [super willMoveToSuperview:newSuperview];

    UIResponder *next = newSuperview;
    while (next != nil) {
        if ([next isKindOfClass:[UIViewController class]]) {
            ((UIViewController *)next).automaticallyAdjustsScrollViewInsets = NO;
            break;
        }
        next = next.nextResponder;
    }
}
```
 
## 单个cell刷新 

调用`- (void)reloadCellAtIndex:(NSInteger)index;`方法刷新指定index。
某些情况需要刷新某一个cell的UI显示，比如红点示例里面。
 
## 自定义建议

`JXCategoryView`即使提供了灵活扩展，也不可能满足所有情况。未能满足特殊需求的情况，建议通过fork仓库，实现特殊效果。
